%if False

> {-# LANGUAGE TypeSynonymInstances, FlexibleInstances #-}
> module Talk.OnlyParsing where
> 
> import Talk.AST
> import Text.ParserCombinators.Parsec (Parser, spaces, string, many1, GenParser, parseTest)
> import Control.Applicative
> import Control.Monad

> instance Applicative (GenParser Char st) where
>   pure = return
>   (<*>) = ap

> instance Alternative (GenParser Char st) where
>   empty  =  mzero
>   (<|>)  =  mplus

%endif

Parser
------

%format exp0 = exp "_\Varid{0}"
%format exp1 = exp "_\Varid{1}"

> parseSK = exp1 where
>   exp0    =    S  <$  tok "S"
>           <|>  K  <$  tok "K" 
>           <|>  tok "(" *> exp1 <* tok ")"
>       
>   exp1    =    foldl App <$> exp0 <*> many exp0
>   
>   tok k         =    string k <* spaces

%if False

> test = parseTest parseSK "SKK(SKK)"

%endif
