%if False

> {-# LANGUAGE TypeSynonymInstances, FlexibleInstances, TemplateHaskell, NoMonomorphismRestriction #-}
> module Talk.Syntax where
> 
> import Prelude ()
> import Talk.AST
> import Unparse
> import Iso
> import TH
> 
> $(defineIsomorphisms ''SK)
>
> string = text
> spaces = pure ()

%endif

Unified Syntax Description
--------------------------

> syntaxSK = exp1 where
>   exp0   =    s  <$>  tok "S"
>          <|>  k  <$>  tok "K"
>          <|>  tok "(" *> exp1 <* tok ")"
>   
>   exp1   =    foldl app <$> exp0 <*> many exp0
>   
>   tok k  =    string k <* spaces

%if False

> test_parse  =  parse syntaxSK "SKK(SKK)"
> test_print  =  print syntaxSK (App (App (App S K) K) (App (App S K) K))

%endif
