
Example language
----------------

 * Concrete syntax

< e  ::=  "S" | "K"
<    |    e e
<    |    "(" e ")"

------
 
 * Abstract syntax

%if False

> module Talk.AST where

%endif

> data SK 
>   =  {-"\alert<6>{"-} S | K {-"}"-} 
>   |  {-"\alert<7>{"-} App SK SK {-"}"-}

%if False

>   deriving Show

%endif

Left Associative Application
----------------------------

 * String

< "SKK(SKK)"
< 
< "((SK)K)((SK)K)"

----------------

 * AST

\begin{postit}
\small\it
\begin{tikzpicture}
  [level 1/.style={sibling distance=4em, level distance=2em},
   level 2/.style={sibling distance=2em, level distance=2em},
   level 3/.style={sibling distance=2em, level distance=2em}]
\node {$\Varid{App}$} 
  child {node {$\Varid{App}$}
    child {node {$\Varid{App}$}
      child {node {$\Varid{S}$}}
      child {node {$\Varid{K}$}}}
    child {node {$\Varid{K}$}}}
  child {node {$\Varid{App}$}
    child {node {$\Varid{App}$}
      child {node {$\Varid{S}$}}
      child {node {$\Varid{K}$}}}
    child {node {$\Varid{K}$}}};
\end{tikzpicture}
\end{postit}
